<template lang="pug">
div(v-bind:class='{ content: viewOnly, dashboard: !viewOnly }')
  .column.justify-center.full-height
    .full-width.bordered(v-bind:class='{ checkin: viewOnly }')
      .full-width.q-px-md.text-h5.q-mx-lg {{ index ? "(" + index + ") " + currentQuestion.name : currentQuestion.name }}
        .row.justify-between.q-mt-lg.full-width
          .col-4
            .text-subtitle1.text-bold {{ getFirstOptions(currentQuestion.options) }}
          .col-4
            .text-subtitle1.text-bold.align-right {{ getLastOptions(currentQuestion.options) }}
        .row
          q-slider.q-mt-sm(
            :min='0',
            :max='Object.values(currentQuestion.options).length - 1',
            color='primary',
            markers,
            :switch-label-side='viewOnly',
            label,
            :label-always='viewOnly',
            :label-value='getLabel(currentQuestion.options, answer)',
            @change='updateSelection',
            v-model='answer'
          )
</template>

<script>
export default {
  name: 'Question',
  props: {
    sequence: null,
    viewOnly: null,
    response: null,
    update: null,
    currentQuestion: null,
    index: null,
  },
  data: () => {
    return {
      answer: null,
    };
  },
  methods: {
    getFirstOptions(options) {
      return Object.values(options)[0];
    },
    getLastOptions(options) {
      const tmp = Object.values(options);
      return tmp[tmp.length - 1];
    },
    getLabel(options, idx) {
      return Object.values(options)[idx];
    },
    async updateSelection(value) {
      if (!this.viewOnly) this.$emit('update', value);
    },
  },
  computed: {},
  watch: {
    response: {
      immediate: true,
      handler(newVal) {
        this.answer = newVal;
      },
    },
  },
};
</script>

<style lang="scss" scoped>
.align-right {
  text-align: right;
}

.content {
  position: absolute;
  height: 720px;
  width: 480px;
  left: 10px;
}
.dashboard {
  .text-h5 {
    font-size: 12pt;
  }
}
</style>
